%Simulation 4: Incomplete Markets, Heterogeneous Agents, 3 Assets  without Collateral%


%parameters

syms E H e h; %assets recovery values and initial endowments
syms e1o e2o e3o e4o  e5o e6o e7o e8o e9o ;%initial endowments consumption good optimist
syms e1p e2p e3p e4p  e5p e6p e7p e8p e9p ;%initial endowments consumption good pes
syms po pp ;%probabilities
syms delta;%discounting

% variables

syms x1o x2o x3o  x4o x5o x6o x7o  x8o  x9o ; %consumption opt
syms E1o E2o E3o  H1o H2o H3o ;%asset holdings opt

syms x1p x2p x3p  x4p x5p x6p x7p  x8p  x9p ;%consumption pes
syms E1p  E2p E3p  H1p  H2p H3p ;%asset holding pes

syms x1 x2 x3 x4 x5 x6 ;%asset prices

%values parameters

%assets

g=1;
b=1;
h=2;
G=.2;
B=.05;
H=.2;

%utilities

delta=1;

po=.9;
pp=.5;

%endowments

e1o=20;
e2o=20;
e3o=20;
e4o=20;
e5o=20;
e6o=20;
e7o=20;
e8o=20;
e9o=20;


e1p=2000;
e2p=2000;
e3p=2000;
e4p=2000;
e5p=2000;
e6p=2000;
e7p=2000;
e8p=2000;
e9p=2000;

% values variables

%here I assume regime of asset holdings coparten E in 1

G2o=g;
B2o=b;
G3o=g;
B3o=b;


H1o=h;

H3o=h;


G2p=0;
B2p=0;
G3p=0;
B3p=0;


H1p=0;

H3p=0;





%varialbles

x1=x(1);
x2=x(2);
x3=x(3);
x4=x(4);
x5=x(5);
x6=x(6);
x7=x(7);
x8=x(8);
x9=x(9);
G1o=x(10);
B1o=x(11);
H2o=x(12);





%equations




%Budget Constraints Optimist


x1o=  e1o - x1*(G1o-g/2) -x2*(B1o-b/2)- x3*(H1o-h/2)  ;
x2o=  e2o - x4*(G2o - G1o) -x5*(B2o-B1o)- x6*( H2o- H1o)   ;
x3o = e3o - x7*(G3o-G1o)-x8*(B3o-B1o) - x9*(H3o-H1o) ;
 
x4o=  e4o  + H2o  + G2o+B2o;
x5o=e5o + H2o  + G*G2o+ B*B2o;
x6o=e6o+ H3o  + G3o+B3o;

x7o=e7o + H3o  + G*G3o+ B*B3o;
x8o=e8o + H*H3o  + G3o+B3o;
x9o=e9o+ H*H3o  + G*G3o+ B*B3o;


 
%marekt clearing

G1p=g-G1o;
B1p=b-B1o;
H2p=h-H2o;


%Budget Constraint Pesimist




x1p=  e1p - x1*(G1p-g/2) - x2*(B1p-b/2)- x3*(H1p-h/2)  ;
x2p=  e2p - x4*(G2p - G1p) -x5*(B2p-B1p)- x6*( H2p- H1p)   ;
x3p = e3p - x7*(G3p-G1p)-x8*(B3p-B1p) - x9*(H3p-H1p) ;
 
x4p=  e4p  + H2p  + G2p+B2p;
x5p=e5p+ H2p  + G*G2p+ B*B2p;
x6p=e6p+ H3p  + G3p+B3p;

x7p=e7p + H3p  + G*G3p+ B*B3p;
x8p=e8p + H*H3p  + G3p+B3p;
x9p=e9p+ H*H3p  + G*G3p+ B*B3p;

 

 



%Checking FOC

%for the regime to be ok all of the following conditions should be
%positive. I am testing that the foc that I didn't impose, they indeed do
%not hold.

%Optimist
%s=1


%s=2



%s=3




%Pesimist
%s=1




h1p= (1/x1p)*(x3) - pp*delta*(1/x2p)*(x6) - (1-pp)*delta*(1/x3p)*(x9)



%s=2



g2p= (1/x2p)*(x4) - pp*delta*(1/x4p)*(1) - (1-pp)*delta*(1/x5p)*(G)
b2p= (1/x2p)*(x5) - pp*delta*(1/x4p)*(1) - (1-pp)*delta*(1/x5p)*(B)


%s=3

g3p= (1/x3p)*(x7) - pp*pp*delta*(1/x6p)*(1) - pp*(1-pp)*delta*(1/x7p)*(G)- pp*(1-pp)*delta*(1/x8p)*(1)- (1-pp)*(1-pp)*delta*(1/x9p)*(G)
b3p= (1/x3p)*(x8) - pp*pp*delta*(1/x6p)*(1) - pp*(1-pp)*delta*(1/x7p)*(B)- pp*(1-pp)*delta*(1/x8p)*(1)- (1-pp)*(1-pp)*delta*(1/x9p)*(B)
h3p= (1/x3p)*(x9) - pp*pp*delta*(1/x6p)*(1) - pp*(1-pp)*delta*(1/x7p)*(1)- pp*(1-pp)*delta*(1/x8p)*(H)- (1-pp)*(1-pp)*delta*(1/x9p)*(H)


CG=(x4-x7)/x4*100;
FG=(x1-x7)/x1*100;
CB=(x5-x8)/x5*100;
FB=(x2-x8)/x2*100;
CH=(x6-x9)/x6*100;
FH=(x3-x9)/x3*100;

p.pg1=x(1);
p.pb1=x(2);
p.ph1=x(3);
p.p2g=x(4);
p.p2b=x(5);
p.p2h=x(6);
p.p3g=x(7);
p.p3b=x(8);
p.p3h=x(9);

Co.x1o=x1o;
Co.x2o=x2o;
Co.x3o=x3o;
Co.x4o=x4o;
Co.x5o=x5o;
Co.x6o=x6o;
Co.x7o=x7o;
Co.x8o=x8o;
Co.x9o=x9o;

Cp.x1p=x1p;
Cp.x2p=x2p;
Cp.x3p=x3p;
Cp.x4p=x4p;
Cp.x5p=x5p;
Cp.x6p=x6p;
Cp.x7p=x7p;
Cp.x8p=x8p;
Cp.x9p=x9p;

Ao.G1o=G1o;
Ao.B1o=B1o;
Ao.H1o=H1o;
Ao.G2o=G2o;
Ao.B2o=B2o;
Ao.H2o=H2o;
Ao.G3o=G3o;
Ao.B3o=B3o;
Ao.H3o=H3o;


Ap.G1p=G1p;
Ap.B1p=B1p;
Ap.H1p=H1p;
Ap.G2p=G2p;
Ap.B2p=B2p;
Ap.H2p=H2p;
Ap.G3p=G3p;
Ap.B3p=B3p;
Ap.H3p=H3p;


p
Co
Cp
Ao
Ap
CG
FG
CB
FB
CH
FH


%s=1


f1p=(pp*delta*(1/x2p) + (1-pp)*delta*(1/x3p))/(1/x1p);

f1o=(po*delta*(1/x2o) + (1-po)*delta*(1/x3o))/(1/x1o);

w1=f1p/f1o-1;


%s=2


f2p=(pp*delta*(1/x4p) + (1-pp)*delta*(1/x5p))/(1/x2p);

f2o=(po*delta*(1/x4o) + (1-po)*delta*(1/x5o))/(1/x2o);

w2=f2p/f2o-1;

%s=3

f3p=(pp*pp*delta*(1/x6p) + pp*(1-pp)*delta*(1/x7p)+ pp*(1-pp)*delta*(1/x8p)+ (1-pp)*(1-pp)*delta*(1/x9p))/(1/x3p);

f3o=(po*po*delta*(1/x6o) + po*(1-po)*delta*(1/x7o)+ po*(1-po)*delta*(1/x8o)+ (1-po)*(1-po)*delta*(1/x9o))/(1/x3o);

w3=f3p/f3o-1;

w1
w2
w3
mu2= (po*(1/x2o))/(po*(1/x2o) + (1-po)*(1/x3o));
mu3=((1-po)*(1/x3o))/(po*(1/x2o) + (1-po)*(1/x3o));
mu4= (po*(1/x4o))/(po*(1/x4o) + (1-po)*(1/x5o));
mu5= ((1-po)*(1/x5o))/(po*(1/x4o) + (1-po)*(1/x5o));
mu6= (po*po*(1/x6o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu7= (po*(1-po)*(1/x7o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu8= (po*(1-po)*(1/x8o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu9= ((1-po)*(1-po)*(1/x9o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));

mu2
mu3
mu4
mu5
mu6
mu7
mu8
mu9

