clear all


%Simulation 3: Incomplete Markets, Heterogeneous Agents without Collateral%
%parameters

syms E H e h; %assets recovery values and initial endowments
syms e1o e2o e3o e4o  e5o e6o e7o e8o e9o ;%initial endowments consumption good optimist
syms e1p e2p e3p e4p  e5p e6p e7p e8p e9p ;%initial endowments consumption good pes
syms po pp ;%probabilities
syms delta;%discounting

% variables

syms x1o x2o x3o  x4o x5o x6o x7o  x8o  x9o ; %consumption opt
syms E1o E2o E3o  H1o H2o H3o ;%asset holdings opt

syms x1p x2p x3p  x4p x5p x6p x7p  x8p  x9p ;%consumption pes
syms E1p  E2p E3p  H1p  H2p H3p ;%asset holding pes

syms x1 x2 x3 x4 x5 x6 ;%asset prices

%values parameters
%assets

e=2;
h=2;
E=.1;
H=.2;

%utilities

delta=1;

po=.9;
pp=.5;

%endowments

e1o=20;
e2o=20;
e3o=20;
e4o=20;
e5o=20;
e6o=20;
e7o=20;
e8o=20;
e9o=20;


e1p=2000;
e2p=2000;
e3p=2000;
e4p=2000;
e5p=2000;
e6p=2000;
e7p=2000;
e8p=2000;
e9p=2000;

% values variables

%here I assume regime of asset holdings coparten E in 1

E2o=e;
E3o=e;
H1o=h;
H2o=0;
H3o=h;


E2p=0;
E3p=0;

H1p=0;
H2p=h;
H3p=0;





%equations




%Budget Constraints Optimist


x1o=  e1o - x1*(E1o-e/2) - x2*(H1o-h/2)  ;
x2o=  e2o - x3*(E2o - E1o) - x4*( H2o- H1o)   ;
x3o = e3o - x5*(E3o-E1o) - x6*(H3o-H1o) ;
 
x4o=  e4o  + H2o  + E2o ;
x5o=e5o + H2o  + E*E2o;
x6o=e6o+ H3o  + E3o ;

x7o=e7o + H3o  + E*E3o;
x8o=e8o + H*H3o  + E3o ;
x9o=e9o+ H*H3o  + E*E3o ;


 
 %market clearing
 
 E1p=e-E1o;
 



%Budget Constraint Pesimist




x1p=  e1p - x1*(E1p-e/2) - x2*(H1p-h/2)  ;
 x2p=  e2p - x3*(E2p -E1p) - x4*(H2p- H1p)  ;
 x3p = e3p - x5*(E3p-E1p) - x6*(H3p-H1p)  ;
 
 x4p=  e4p + H2p  + E2p ;
 x5p=e5p+ H2p  + E*(E2p) ;
 x6p=e6p+ H3p  + E3p ;
 
 x7p=e7p+ H3p  + E*(E3p);
 x8p=e8p+ H*H3p + E3p;
 x9p=e9p+ H*H3p + E*(E3p);


 
 


%FOC

%here I assume all the above, plus normal foc

%s=1

f1= (1/x1o)*(x1) - po*delta*(1/x2o)*(x3) - (1-po)*delta*(1/x3o)*(x5);
f2= (1/x1o)*(x2) - po*delta*(1/x2o)*(x4) - (1-po)*delta*(1/x3o)*(x6);
f3= (1/x1p)*(x1) - pp*delta*(1/x2p)*(x3) - (1-pp)*delta*(1/x3p)*(x5);



%s=2

f4= (1/x2o)*(x3) - po*delta*(1/x4o)*(1) - (1-po)*delta*(1/x5o)*(E);

f5= (1/x2p)*(x4) - pp*delta*(1/x4p) - (1-pp)*delta*(1/x5p);




%s=3

f6= (1/x3o)*(x5) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(E)- po*(1-po)*delta*(1/x8o)*(1)- (1-po)*(1-po)*delta*(1/x9o)*(E);
f7= (1/x3o)*(x6) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(1)- po*(1-po)*delta*(1/x8o)*(H)- (1-po)*(1-po)*delta*(1/x9o)*(H);




sol=solve(f1,f2,f3,f4,f5,f6,f7)

%here I solve for asset prices and prices of promises

% solution prices

S.x1=double(sol.x1(1));
S.x2=double(sol.x2(1));
S.x3=double(sol.x3(1));
S.x4=double(sol.x4(1));
S.x5=double(sol.x5(1));
S.x6=double(sol.x6(1));
S.E1o=double(sol.E1o(1));



%solution rest of variables.

   
%Optimist

x1o=  e1o - S.x1*(S.E1o-e/2) - S.x2*(H1o-h/2)  ;
x2o=  e2o - S.x3*(E2o - S.E1o) - S.x4*( H2o- H1o)   ;
x3o = e3o - S.x5*(E3o-S.E1o) - S.x6*(H3o-H1o) ;
 
x4o=  e4o  + H2o  + E2o ;
x5o=e5o + H2o  + E*E2o;

x6o=e6o+ H3o  + E3o ;

x7o=e7o + H3o  + E*E3o;
x8o=e8o + H*H3o  + E3o ;
x9o=e9o+ H*H3o  + E*E3o ;


 

E1p=e-S.E1o;

%Budget Constraint Pesimist


x1p=  e1p - S.x1*(E1p-e/2) - S.x2*(H1p-h/2)  ;
 x2p=  e2p - S.x3*(E2p -E1p) - S.x4*(H2p- H1p)  ;
 x3p = e3p - S.x5*(E3p-E1p) - S.x6*(H3p-H1p)  ;
 
 x4p=  e4p + H2p  + E2p ;
 x5p=e5p+ H2p  + E*(E2p) ;
 x6p=e6p+ H3p  + E3p ;
 
 x7p=e7p+ H3p  + E*(E3p);
 x8p=e8p+ H*H3p + E3p;

x9p=e9p+ H*H3p + E*(E3p);




Co.x1o=x1o;
Co.x2o=x2o;
Co.x3o=x3o;
Co.x4o=x4o;
Co.x5o=x5o;
Co.x6o=x6o;
Co.x7o=x7o;
Co.x8o=x8o;
Co.x9o=x9o;

Cp.x1p=x1p;
Cp.x2p=x2p;
Cp.x3p=x3p;
Cp.x4p=x4p;
Cp.x5p=x5p;
Cp.x6p=x6p;
Cp.x7p=x7p;
Cp.x8p=x8p;
Cp.x9p=x9p;



Ao.E1o=S.E1o;
Ao.E2o=e;
Ao.E3o=e;

Ao.H1o=h;
Ao.H2o=H2o;
Ao.H3o=h;


Ap.E1p=e-S.E1o;
Ap.E2p=0;
Ap.E3p=0;

Ap.H1p=0;
Ap.H2p=H2p;
Ap.H3p=0;

%fall in price


FE=(S.x1-S.x5)/S.x1*100;
FH=(S.x2-S.x6)/S.x2*100;

%contagion

CE=(S.x3-S.x5)/S.x3*100;
CH=(S.x4-S.x6)/S.x4*100;



p.p1E=S.x1;
p.p1H=S.x2;
p.p2E=S.x3;
p.p2H=S.x4;
p.p3E=S.x5;
p.p3H=S.x6;




%Checking FOC

%for the regime to be ok all of the following conditions should be
%positive. I am testing that the foc that I didn't impose, they indeed do
%not hold.

%Optimist
%s=1




%s=2


oh2= (1/x2o)*(S.x4) - po*delta*(1/x4o) - (1-po)*delta*(1/x5o)



%s=3




%Pesimist
%s=1


ph1= (1/x1p)*(S.x2) - pp*delta*(1/x2p)*(S.x4) - (1-pp)*delta*(1/x3p)*(S.x6)





%s=2



pe2= (1/x4p)*(S.x3) - pp*delta*(1/x4p)*(1) - (1-pp)*delta*(1/x5p)*(E)




%s=3

pe3= (1/x3p)*(S.x5) - pp*pp*delta*(1/x6p)*(1) - pp*(1-pp)*delta*(1/x7p)*(E)- pp*(1-pp)*delta*(1/x8p)*(1)- (1-pp)*(1-pp)*delta*(1/x9p)*(E)
ph3= (1/x3p)*(S.x6) - pp*pp*delta*(1/x6p)*(1) - pp*(1-pp)*delta*(1/x7p)*(1)- pp*(1-pp)*delta*(1/x8p)*(H)- (1-pp)*(1-pp)*delta*(1/x9p)*(H)



f1= (1/x1o)*(S.x1) - po*delta*(1/x2o)*(S.x3) - (1-po)*delta*(1/x3o)*(S.x5)
f2= (1/x1o)*(S.x2) - po*delta*(1/x2o)*(S.x4) - (1-po)*delta*(1/x3o)*(S.x6)
f3= (1/x1p)*(S.x1) - pp*delta*(1/x2p)*(S.x3) - (1-pp)*delta*(1/x3p)*(S.x5)



%s=2

f4= (1/x2o)*(S.x3) - po*delta*(1/x4o)*(1) - (1-po)*delta*(1/x5o)*(E)

f5= (1/x2p)*(S.x4) - pp*delta*(1/x4p) - (1-pp)*delta*(1/x5p)




%s=3

f6= (1/x3o)*(S.x5) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(E)- po*(1-po)*delta*(1/x8o)*(1)- (1-po)*(1-po)*delta*(1/x9o)*(E)
f7= (1/x3o)*(S.x6) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(1)- po*(1-po)*delta*(1/x8o)*(H)- (1-po)*(1-po)*delta*(1/x9o)*(H)



%liquidity wedge


%s=1


f1p=(pp*delta*(1/x2p) + (1-pp)*delta*(1/x3p))/(1/x1p);

f1o=(po*delta*(1/x2o) + (1-po)*delta*(1/x3o))/(1/x1o);

w1=f1p/f1o-1;


%s=2


f2p=(pp*delta*(1/x4p) + (1-pp)*delta*(1/x5p))/(1/x2p);

f2o=(po*delta*(1/x4o) + (1-po)*delta*(1/x5o))/(1/x2o);

w2=f2p/f2o-1;

%s=3

f3p=(pp*pp*delta*(1/x6p) + pp*(1-pp)*delta*(1/x7p)+ pp*(1-pp)*delta*(1/x8p)+ (1-pp)*(1-pp)*delta*(1/x9p))/(1/x3p);

f3o=(po*po*delta*(1/x6o) + po*(1-po)*delta*(1/x7o)+ po*(1-po)*delta*(1/x8o)+ (1-po)*(1-po)*delta*(1/x9o))/(1/x3o);

w3=f3p/f3o-1;

w1
w2
w3

mu2= (po*(1/x2o))/(po*(1/x2o) + (1-po)*(1/x3o));
mu3=((1-po)*(1/x3o))/(po*(1/x2o) + (1-po)*(1/x3o));
mu4= (po*(1/x4o))/(po*(1/x4o) + (1-po)*(1/x5o));
mu5= ((1-po)*(1/x5o))/(po*(1/x4o) + (1-po)*(1/x5o));
mu6= (po*po*(1/x6o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu7= (po*(1-po)*(1/x7o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu8= (po*(1-po)*(1/x8o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu9= ((1-po)*(1-po)*(1/x9o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));

mu2
mu3
mu4
mu5
mu6
mu7
mu8
mu9

