clear all

%Simulation 4: Incomplete Markets, Heterogeneous Agents, 3 Assets  without Collateral%

%parameters

syms G B H g b h; %assets recovery values and initial endowments
syms e1o e2o e3o e4o  e5o e6o e7o e8o e9o ;%initial endowments consumption good optimist
syms e1p e2p e3p e4p  e5p e6p e7p e8p e9p ;%initial endowments consumption good pes
syms po pp ;%probabilities
syms delta;%discounting

% variables

syms x1o x2o x3o  x4o x5o x6o x7o  x8o  x9o ; %consumption opt
syms G1o G2o G3o B1o B2o B3o  H1o H2o H3o ;%asset holdings opt

syms x1p x2p x3p  x4p x5p x6p x7p  x8p  x9p ;%consumption pes
syms G1p  G2p G3p B1p B2p B3p H1p  H2p H3p ;%asset holding pes

syms x1 x2 x3 x4 x5 x6 x7 x8 x9;%asset prices


% values variables

%here I assume regime of asset holdings they share emerging assets at 1


G2o=g;
B2o=b;
G3o=g;
B3o=b;


H1o=h;

H3o=h;


G2p=0;
B2p=0;
G3p=0;
B3p=0;


H1p=0;

H3p=0;





%equations




%Budget Constraints Optimist


x1o=  e1o - x1*(G1o-g/2) -x2*(B1o-b/2)- x3*(H1o-h/2)  ;
x2o=  e2o - x4*(G2o - G1o) -x5*(B2o-B1o)- x6*( H2o- H1o)   ;
x3o = e3o - x7*(G3o-G1o)-x8*(B3o-B1o) - x9*(H3o-H1o) ;
 
x4o=  e4o  + H2o  + G2o+B2o;
x5o=e5o + H2o  + G*G2o+ B*B2o;
x6o=e6o+ H3o  + G3o+B3o;

x7o=e7o + H3o  + G*G3o+ B*B3o;
x8o=e8o + H*H3o  + G3o+B3o;
x9o=e9o+ H*H3o  + G*G3o+ B*B3o;


 
%marekt clearing

G1p=g-G1o;
B1p=b-B1o;
H2p=h-H2o;


%Budget Constraint Pesimist




x1p=  e1p - x1*(G1p-g/2) - x2*(B1p-b/2)- x3*(H1p-h/2)  ;
x2p=  e2p - x4*(G2p - G1p) -x5*(B2p-B1p)- x6*( H2p- H1p)   ;
x3p = e3p - x7*(G3p-G1p)-x8*(B3p-B1p) - x9*(H3p-H1p) ;
 
x4p=  e4p  + H2p  + G2p+B2p;
x5p=e5p+ H2p  + G*G2p+ B*B2p;
x6p=e6p+ H3p  + G3p+B3p;

x7p=e7p + H3p  + G*G3p+ B*B3p;
x8p=e8p + H*H3p  + G3p+B3p;
x9p=e9p+ H*H3p  + G*G3p+ B*B3p;

 
 


%FOC

%here I assume all the above, plus normal foc

%s=1

f1= (1/x1o)*(x1) - po*delta*(1/x2o)*(x4) - (1-po)*delta*(1/x3o)*(x7);
f2= (1/x1o)*(x2) - po*delta*(1/x2o)*(x5) - (1-po)*delta*(1/x3o)*(x8);
f3= (1/x1o)*(x3) - po*delta*(1/x2o)*(x6) - (1-po)*delta*(1/x3o)*(x9);
f4= (1/x1p)*(x1) - pp*delta*(1/x2p)*(x4) - (1-pp)*delta*(1/x3p)*(x7);
f5= (1/x1p)*(x2) - pp*delta*(1/x2p)*(x5) - (1-pp)*delta*(1/x3p)*(x8);

%s=2

f6= (1/x2o)*(x4) - po*delta*(1/x4o)*(1) - (1-po)*delta*(1/x5o)*(G);
f7= (1/x2o)*(x5) - po*delta*(1/x4o)*(1) - (1-po)*delta*(1/x5o)*(B);
f8= (1/x2o)*(x6) - po*delta*(1/x4o) - (1-po)*delta*(1/x5o);
f9= (1/x2p)*(x6) - pp*delta*(1/x4p) - (1-pp)*delta*(1/x5p);




%s=3

f10= (1/x3o)*(x7) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(G)- po*(1-po)*delta*(1/x8o)*(1)- (1-po)*(1-po)*delta*(1/x9o)*(G);
f11= (1/x3o)*(x8) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(B)- po*(1-po)*delta*(1/x8o)*(1)- (1-po)*(1-po)*delta*(1/x9o)*(B);
f12= (1/x3o)*(x9) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(1)- po*(1-po)*delta*(1/x8o)*(H)- (1-po)*(1-po)*delta*(1/x9o)*(H);



