clear all

%Simulation 5: Incomplete Markets, Heterogeneous Agents, with Collateral%

%parameters

syms E H e h; 
syms e1o e2o e3o e4o  e5o e6o e7o e8o e9o ;
syms e1p e2p e3p e4p  e5p e6p e7p e8p e9p ;
syms po pp ;
syms delta;

% variables

syms x1o x2o x3o  x4o x5o x6o x7o  x8o  x9o ;
syms E1o E2o E3o  H1o H2o H3o ;
syms phi1  phi2 phi3 ;


syms x1p x2p x3p  x4p x5p x6p x7p  x8p  x9p ;
syms E1p  E2p E3p  H1p  H2p H3p ;
syms theta1  theta2 theta3 ;
syms x1 x2 x3 x4 x5 x6 ;
syms x7 x8 x9 ;

%values parameters
e=2;
h=2;
E=.1;
H=.2;


delta=1;

po=.9;
pp=.5;

e1o=20;
e2o=20;
e3o=20;
e4o=20;
e5o=20;
e6o=20;
e7o=20;
e8o=20;
e9o=20;

e1p=2000;
e2p=2000;
e3p=2000;
e4p=2000;
e5p=2000;
e6p=2000;
e7p=2000;
e8p=2000;
e9p=2000;

% values variables

E1o=0;
E2o=0;
E3o=0;
H1o=h;
H2o=0;
H3o=h;

E1p=0;
E2p=0;
E3p=0;

H1p=0;
H2p=h;
H3p=0;


phi1=e;
phi2=e;
phi3=e;




%equations




%Budget Constraints Optimist


x1o=  e1o - x1*(E1o-e/2) - x2*(H1o-h/2) + x7*phi1 - x1*phi1 ;
x2o=  e2o - x3*(E2o - (E1o+phi1)) - x4*(H2o- H1o) - phi1*x5 +  x8*phi2 - x3*phi2  ;
x3o = e3o - x5*(E3o-(E1o+phi1)) - x6*(H3o-H1o) - phi1*x5 + x9*phi3 - x5*phi3;
 
x4o=  e4o-phi2*E  + H2o  + E2o + phi2;
x5o=e5o-phi2*E + H2o  + E*(E2o + phi2);
x6o=e6o-phi3*E+ H3o  + E3o + phi3;

x7o=e7o-phi3*E + H3o  + E*(E3o + phi3);
x8o=e8o-phi3*E + H*H3o  + E3o + phi3;
x9o=e9o-phi3*E + H*H3o  + E*(E3o + phi3);


 
 


%Market Clearing

%s=1


theta1=phi1;

%s=2

theta2=phi2;
%s=3

theta3=phi3;




%Budget Constraint Pesimist

x1p=  e1p - x1*(E1p-e/2) - x2*(H1p-h/2) - x7*theta1 ;
 x2p=  e2p - x3*(E2p -E1p) - x4*(H2p- H1p) + theta1*x5 - x8*theta2  ;
 x3p = e3p - x5*(E3p-E1p) - x6*(H3p-H1p) + theta1*x5 - x9*theta3 ;
 
 x4p=  e4p+theta2*E + H2p  + E2p ;
 x5p=e5p+theta2*E+ H2p  + E*(E2p) ;
 x6p=e6p+theta3*E + H3p  + E3p ;
 
 x7p=e7p+theta3*E  + H3p  + E*(E3p);
 x8p=e8p+theta3*E  + H*H3p + E3p;
 x9p=e9p+theta3*E + H*H3p + E*(E3p);


 
 


%FOC

%s=1

f1= (1/x1o)*(x1-x7) - po*delta*(1/x2o)*(x3-x5) - (1-po)*delta*(1/x3o)*(x5-x5);
f2= (1/x1o)*(x2) - po*delta*(1/x2o)*(x4) - (1-po)*delta*(1/x3o)*(x6);
f3= (1/x1p)*x7 - pp*delta*(1/x2p)*x5 - (1-pp)*delta*(1/x3p)*x5;


%s=2

f4= (1/x2o)*(x3-x8) - po*delta*(1/x4o)*(1-E) - (1-po)*delta*(1/x5o)*(E-E);
f5= (1/x2p)*(x4) - pp*delta*(1/x4p) - (1-pp)*delta*(1/x5p);
f6= (1/x2p)*x8 - pp*delta*(1/x4p)*E - (1-pp)*delta*(1/x5p)*E;



%s=3

f7= (1/x3o)*(x5-x9) - po*po*delta*(1/x6o)*(1-E) - po*(1-po)*delta*(1/x7o)*(E-E)- po*(1-po)*delta*(1/x8o)*(1-E)- (1-po)*(1-po)*delta*(1/x9o)*(E-E);
f8= (1/x3o)*(x6) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(1)- po*(1-po)*delta*(1/x8o)*(H)- (1-po)*(1-po)*delta*(1/x9o)*(H);
f9= (1/x3p)*x9 - pp*pp*delta*(1/x6p)*(E) - pp*(1-pp)*delta*(1/x7p)*(E)- pp*(1-pp)*delta*(1/x8p)*(E)- (1-pp)*(1-pp)*delta*(1/x9p)*(E);




sol=solve(f1,f2,f3,f4,f5,f6,f7,f8,f9)


% solution prices

S.x1=double(sol.x1);
S.x2=double(sol.x2);
S.x3=double(sol.x3);
S.x4=double(sol.x4);
S.x5=double(sol.x5);
S.x6=double(sol.x6);
S.x7=double(sol.x7);
S.x8=double(sol.x8);
S.x9=double(sol.x9);





%solution rest of variables.

   
%Optimist

x1o=  e1o - S.x1*(E1o-e/2) - S.x2*(H1o-h/2) + S.x7*phi1 - S.x1*phi1 ;
 x2o=  e2o - S.x3*(E2o - (E1o+phi1)) - S.x4*( H2o- H1o) - phi1*S.x5 + S.x8*phi2 - S.x3*phi2  ;
 x3o = e3o - S.x5*(E3o-(E1o+phi1)) - S.x6*(H3o-H1o) - phi1*S.x5 + S.x9*phi3 - S.x5*phi3 ;
 
 x4o=  e4o-phi2*E + H2o  + E2o + phi2;
 x5o=e5o-phi2*E + H2o  + E*(E2o + phi2);
 x6o=e6o-phi3*E + H3o  + E3o + phi3;
 
 x7o=e7o-phi3*E + H3o  + E*(E3o + phi3);
 x8o=e8o-phi3*E + H*H3o  + E3o + phi3;
 x9o=e9o-phi3*E + H*H3o  + E*(E3o + phi3);


%Budget Constraint Pesimist

x1p=  e1p - S.x1*(E1p-e/2) - S.x2*(H1p-h/2) - S.x7*theta1 ;
 x2p=  e2p - S.x3*(E2p -E1p) - S.x4*(H2p- H1p) + theta1*S.x5 - S.x8*theta2  ;
 x3p = e3p - S.x5*(E3p-E1p) - S.x6*(H3p-H1p) + theta1*S.x5 - S.x9*theta3 ;
 
 x4p=  e4p+theta2*E + H2p  + E2p ;
 x5p=e5p+theta2*E+ H2p  + E*(E2p) ;
 x6p=e6p+theta3*E + H3p  + E3p ;
 
 x7p=e7p+theta3*E  + H3p  + E*(E3p);
 x8p=e8p+theta3*E  + H*H3p + E3p;
 x9p=e9p+theta3*E + H*H3p + E*(E3p);




Co.x1o=x1o;
Co.x2o=x2o;
Co.x3o=x3o;
Co.x4o=x4o;
Co.x5o=x5o;
Co.x6o=x6o;
Co.x7o=x7o;
Co.x8o=x8o;
Co.x9o=x9o;

Cp.x1p=x1p;
Cp.x2p=x2p;
Cp.x3p=x3p;
Cp.x4p=x4p;
Cp.x5p=x5p;
Cp.x6p=x6p;
Cp.x7p=x7p;
Cp.x8p=x8p;
Cp.x9p=x9p;

L.phi1=phi1;
L.phi2=phi2;
L.phi3=phi3;


Ao.E1o=0;
Ao.E2o=0;
Ao.E3o=0;

Ao.H1o=h;
Ao.H2o=0;
Ao.H3o=h;


Ap.E1p=0;
Ap.E2p=0;
Ap.E3p=0;

Ap.H1p=0;
Ap.H2p=h;
Ap.H3p=0;


FE=(S.x1-S.x5)/S.x1*100;
FH=(S.x2-S.x6)/S.x2*100;
CE=(S.x3-S.x5)/S.x3*100;
CH=(S.x4-S.x6)/S.x4*100;

p.p1E=S.x1;
p.p1H=S.x2;
p.p2E=S.x3;
p.p2H=S.x4;
p.p3E=S.x5;
p.p3H=S.x6;
p.pi1=S.x7;
p.pi2=S.x8;
p.pi3=S.x9;





%Checking FOC

%Optimist
%s=1

oe1= (1/x1o)*(S.x1) - po*delta*(1/x2o)*(S.x3) - (1-po)*delta*(1/x3o)*(S.x5)
ob1= (1/x1o)*S.x7 - po*delta*(1/x2o)*S.x5 - (1-po)*delta*(1/x3o)*S.x5




%s=2


oe2= (1/x2o)*(S.x3) - po*delta*(1/x4o)*(1) - (1-po)*delta*(1/x5o)*(E)
oh2= (1/x2o)*(S.x4) - po*delta*(1/x4o) - (1-po)*delta*(1/x5o)
ob2= (1/x2o)*S.x8 - po*delta*(1/x4o)*E - (1-po)*delta*(1/x5o)*E


%s=3


oe3= (1/x3o)*(S.x5) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(E)- po*(1-po)*delta*(1/x8o)*(1)- (1-po)*(1-po)*delta*(1/x9o)*(E)
ob3= (1/x3o)*S.x9 - po*po*delta*(1/x6o)*(E) - po*(1-po)*delta*(1/x7o)*(E)- po*(1-po)*delta*(1/x8o)*(E)- (1-po)*(1-po)*delta*(1/x9o)*(E)


%Pesimist
%s=1

pe1= (1/x1p)*(S.x1) - pp*delta*(1/x2p)*(S.x3) - (1-pp)*delta*(1/x3p)*(S.x5)
ph1= (1/x1p)*(S.x2) - pp*delta*(1/x2p)*(S.x4) - (1-pp)*delta*(1/x3p)*(S.x6)





%s=2



pe2= (1/x4p)*(S.x3) - pp*delta*(1/x4p)*(1) - (1-pp)*delta*(1/x5p)*(E)




%s=3

pe3= (1/x3p)*(S.x5) - pp*pp*delta*(1/x6p)*(1) - pp*(1-pp)*delta*(1/x7p)*(E)- pp*(1-pp)*delta*(1/x8p)*(1)- (1-pp)*(1-pp)*delta*(1/x9p)*(E)
ph3= (1/x3p)*(S.x6) - pp*pp*delta*(1/x6p)*(1) - pp*(1-pp)*delta*(1/x7p)*(1)- pp*(1-pp)*delta*(1/x8p)*(H)- (1-pp)*(1-pp)*delta*(1/x9p)*(H)




%FOC

%s=1

f1= (1/x1o)*(S.x1-S.x7) - po*delta*(1/x2o)*(S.x3-S.x5) - (1-po)*delta*(1/x3o)*(S.x5-S.x5)
f2= (1/x1o)*(S.x2) - po*delta*(1/x2o)*(S.x4) - (1-po)*delta*(1/x3o)*(S.x6)
f3= (1/x1p)*S.x7 - pp*delta*(1/x2p)*S.x5 - (1-pp)*delta*(1/x3p)*S.x5


%s=2

f4= (1/x2o)*(S.x3-S.x8) - po*delta*(1/x4o)*(1-E) - (1-po)*delta*(1/x5o)*(E-E)
f5= (1/x2p)*(S.x4) - pp*delta*(1/x4p) - (1-pp)*delta*(1/x5p)
f6= (1/x2p)*S.x8 - pp*delta*(1/x4p)*E - (1-pp)*delta*(1/x5p)*E



%s=3

f7= (1/x3o)*(S.x5-S.x9) - po*po*delta*(1/x6o)*(1-E) - po*(1-po)*delta*(1/x7o)*(E-E)- po*(1-po)*delta*(1/x8o)*(1-E)- (1-po)*(1-po)*delta*(1/x9o)*(E-E)
f8= (1/x3o)*(S.x6) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(1)- po*(1-po)*delta*(1/x8o)*(H)- (1-po)*(1-po)*delta*(1/x9o)*(H)
f9= (1/x3p)*S.x9 - pp*pp*delta*(1/x6p)*(E) - pp*(1-pp)*delta*(1/x7p)*(E)- pp*(1-pp)*delta*(1/x8p)*(E)- (1-pp)*(1-pp)*delta*(1/x9p)*(E)

%collateral and payoff value


%s=1
ae1=po*delta*(1/x2o)*(S.x3) + (1-po)*delta*(1/x3o)*(S.x5);
PVE1=ae1/(1/x1o);
r1=(S.x7/S.x5)-1;
f1= (po*delta*(1/x2o) + (1-po)*delta*(1/x3o))/(1/x1o);
w1=(1/(f1*(1+r1)))-1;
CVE1=(1/(1+r1))*(w1/(1+w1))*S.x5;


%s=2

ae2=po*delta*(1/x4o)*(1) + (1-po)*delta*(1/x5o)*(E);
PVE2=ae2/(1/x2o);
r2= (S.x8/E)-1;
f2=(po*delta*(1/x4o) + (1-po)*delta*(1/x5o))/(1/x2o);
w2=(1/(f2*(1+r2)))-1;
CVE2=(1/(1+r2))*(w2/(1+w2))*E;


%s=3
ae3=po*po*delta*(1/x6o)*(1) + po*(1-po)*delta*(1/x7o)*(E)+ po*(1-po)*delta*(1/x8o)*(1)+ (1-po)*(1-po)*delta*(1/x9o)*(E);
PVE3=ae3/(1/x3o);
r3=(S.x9/E)-1;
f3=(po*po*delta*(1/x6o) + po*(1-po)*delta*(1/x7o)+ po*(1-po)*delta*(1/x8o)+ (1-po)*(1-po)*delta*(1/x9o))/(1/x3o);
w3=(1/(f3*(1+r3)))-1;
CVE3=(1/(1+r3))*(w3/(1+w3))*E;

PVE1
CVE1
w1
PVE2
CVE2
w2
PVE3
CVE3
w3

FE 
CE

m1= (S.x1-S.x7)/S.x1
m2= (S.x3-S.x8)/S.x3
m3= (S.x5-S.x9)/S.x5

1-m1
1-m2
1-m3

(PVE2-PVE3)/S.x3*100
(PVE1-PVE3)/S.x1*100
(CVE2-CVE3)/S.x3*100
(CVE1-CVE3)/S.x1*100

mu2= (po*(1/x2o))/(po*(1/x2o) + (1-po)*(1/x3o));
mu3=((1-po)*(1/x3o))/(po*(1/x2o) + (1-po)*(1/x3o));
mu4= (po*(1/x4o))/(po*(1/x4o) + (1-po)*(1/x5o));
mu5= ((1-po)*(1/x5o))/(po*(1/x4o) + (1-po)*(1/x5o));
mu6= (po*po*(1/x6o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu7= (po*(1-po)*(1/x7o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu8= (po*(1-po)*(1/x8o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu9= ((1-po)*(1-po)*(1/x9o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));

mu2
mu3
mu4
mu5
mu6
mu7
mu8
mu9

