clear all

%Simulation 6: Incomplete Markets, Heterogeneous Agents, 3 Assets  with Collateral%

%parameters

syms H G B h g b; 
syms e1o e2o e3o e4o  e5o e6o e7o e8o e9o;
syms e1p e2p e3p e4p  e5p e6p e7p e8p e9p;
syms po pp;
syms delta;




% variables


syms x1o x2o x3o  x4o x5o x6o x7o  x8o  x9o ;
syms G1o G2o G3o  B1o B2o B3o  H1o H2o H3o ;
syms phi1G   phi2G phi3G  phi1B   phi2B phi3B ;
syms x1p x2p x3p  x4p x5p x6p x7p  x8p  x9p ;
syms G1p G2p G3p  B1p B2p B3p  H1p H2p H3p ;
syms theta1G  theta2G theta3G  theta1B  theta2B theta3B ;
syms x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15  ;



%values parameters
g=1;
b=1;
h=2;
G=.2;
B=.05;
H=.2;


delta=1;

po=.9;
pp=.5;

e1o=20;
e2o=20;
e3o=20;
e4o=20;
e5o=20;
e6o=20;
e7o=20;
e8o=20;
e9o=20;

e1p=2000;
e2p=2000;
e3p=2000;
e4p=2000;
e5p=2000;
e6p=2000;
e7p=2000;
e8p=2000;
e9p=2000;


% values variables




G1o=0;
G2o=0;
G3o=0;
B1o=0;
B2o=0;
B3o=0;

H1o=h;
H2o=0;
H3o=h;

G1p=0;
G2p=0;
G3p=0;

B1p=0;
B2p=0;
B3p=0;

H1p=0;
H2p=h;
H3p=0;

phi1G=g;
phi2G=g;
phi3G=g;
phi1B=b;
phi2B=b;
phi3B=b;


%equations

%Budget Constraints Optimist

x1o=  e1o - x1*(G1o-g/2) - x2*(B1o-b/2) -x3*(H1o-h/2) + x10*phi1G - x1*phi1G + x11*phi1B - x2*phi1B;
 x2o= e2o - phi1G*x7 - phi1B*x8- x4*(G2o-(G1o+phi1G))- x5*(B2o-(B1o+phi1B)) - x6*(H2o-H1o)+ x12*phi2G - x4*phi2G + x13*phi2B- x5*phi2B   ;
 x3o= e3o - phi1G*x7 - phi1B*x8 -x7*(G3o-(G1o+phi1G))- x8*(B3o-(B1o+phi1B)) - x9*(H3o-H1o) +x14*phi3G - x7*phi3G + x15*phi3B -x8*phi3B ;
 x4o= e4o - phi2G*G - phi2B*B + H2o  + G2o + phi2G +B2o+phi2B;
 x5o=e5o-phi2G*G-phi2B*B + H2o  + G*(G2o + phi2G) +B*(B2o+phi2B);
x6o=e6o-phi3G*G-phi3B*B+ H3o + G3o + phi3G +B3o+phi3B;
 x7o=e7o-phi3G*G-phi3B*B+ H3o + G*(G3o + phi3G) +B*(B3o+phi3B);
 x8o=e8o-phi3G*G-phi3B*B+ H*H3o + G3o + phi3G +B3o+phi3B;
 x9o=e9o-phi3G*G-phi3B*B+ H*H3o + G*(G3o + phi3G) +B*(B3o+phi3B);





%Market Clearing

%s=1

theta1G=phi1G;
theta1B=phi1B;

%s=2

theta2G=phi2G;
theta2B=phi2B;

%s=3

theta3G=phi3G;
theta3B=phi3B;

%Budget Constraint Pesimist

x1p=  e1p - x1*(G1p-g/2) - x2*(B1p-b/2) -x3*(H1p-h/2) - x10*theta1G - x11*theta1B ;
x2p= e2p + theta1G*x7 +theta1B*x8- x4*(G2p-(G1p))- x5*(B2p-(B1p)) - x6*(H2p-H1p)- x12*theta2G- x13*theta2B   ;
x3p= e3p + theta1G*x7 +theta1B*x8   - x7*(G3p-(G1p))- x8*(B3p-(B1p)) - x9*(H3p-H1p) - x14*theta3G - x15*theta3B ;
x4p=  e4p+theta2G*G+theta2B*B + H2p  + G2p  +B2p;
x5p=e5p+theta2G*G+theta2B*B+ H2p  + G*(G2p) +B*(B2p);
x6p=e6p+theta3G*G+theta3B*B+ H3p + G3p + B3p;
x7p=e7p+theta3G*G+theta3B*B+ H3p + G*(G3p) +B*(B3p);
x8p=e8p+theta3G*G+theta3B*B+ H*H3p + G3p  +B3p;
x9p=e9p+theta3G*G+theta3B*B+ H*H3p + G*(G3p) +B*(B3p);

%FOC

%s=1

f1= (1/x1o)*(x1-x10) - po*delta*(1/x2o)*(x4-x7) - (1-po)*delta*(1/x3o)*(x7-x7);
f2= (1/x1o)*(x2-x11) - po*delta*(1/x2o)*(x5-x8) - (1-po)*delta*(1/x3o)*(x8-x8);
f3= (1/x1o)*(x3) - po*delta*(1/x2o)*(x6) - (1-po)*delta*(1/x3o)*(x9);
f4= (1/x1p)*x10 - pp*delta*(1/x2p)*x7 - (1-pp)*delta*(1/x3p)*x7;
f5= (1/x1p)*x11 - pp*delta*(1/x2p)*x8 - (1-pp)*delta*(1/x3p)*x8;

%s=2

f6= (1/x2o)*(x4-x12) - po*delta*(1/x4o)*(1-G) - (1-po)*delta*(1/x5o)*(G-G);
f7= (1/x2o)*(x5-x13) - po*delta*(1/x4o)*(1-B) - (1-po)*delta*(1/x5o)*(B-B);
f8= (1/x2p)*(x6) - pp*delta*(1/x4p) - (1-pp)*delta*(1/x5p);
f9= (1/x2p)*x12 - pp*delta*(1/x4p)*G - (1-pp)*delta*(1/x5p)*G;
f10= (1/x2p)*x13 - pp*delta*(1/x4p)*B - (1-pp)*delta*(1/x5p)*B;

%s=3

f11= (1/x3o)*(x7-x14) - po*po*delta*(1/x6o)*(1-G) - po*(1-po)*delta*(1/x7o)*(G-G)- po*(1-po)*delta*(1/x8o)*(1-G)- (1-po)*(1-po)*delta*(1/x9o)*(G-G);
f12= (1/x3o)*(x8-x15) - po*po*delta*(1/x6o)*(1-B) - po*(1-po)*delta*(1/x7o)*(B-B)- po*(1-po)*delta*(1/x8o)*(1-B)- (1-po)*(1-po)*delta*(1/x9o)*(B-B);
f13= (1/x3o)*(x9) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(1)- po*(1-po)*delta*(1/x8o)*(H)- (1-po)*(1-po)*delta*(1/x9o)*(H);
f14= (1/x3p)*x14 - pp*pp*delta*(1/x6p)*(G) - pp*(1-pp)*delta*(1/x7p)*(G)- pp*(1-pp)*delta*(1/x8p)*(G)- (1-pp)*(1-pp)*delta*(1/x9p)*(G);
f15= (1/x3p)*x15- pp*pp*delta*(1/x6p)*(B) - pp*(1-pp)*delta*(1/x7p)*(B)- pp*(1-pp)*delta*(1/x8p)*(B)- (1-pp)*(1-pp)*delta*(1/x9p)*(B);



sol=solve(f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f11,f12,f13,f14,f15)



% solution prices

S.x1=double(sol.x1);
S.x2=double(sol.x2);
S.x3=double(sol.x3);
S.x4=double(sol.x4);
S.x5=double(sol.x5);
S.x6=double(sol.x6);
S.x7=double(sol.x7);
S.x8=double(sol.x8);
S.x9=double(sol.x9);
S.x10=double(sol.x10);
S.x11=double(sol.x11);
S.x12=double(sol.x12);
S.x13=double(sol.x13);
S.x14=double(sol.x14);
S.x15=double(sol.x15);


%solution rest of variables.

%Budget Constraints Optimist

x1o=  e1o - S.x1*(G1o-g/2) - S.x2*(B1o-b/2) -S.x3*(H1o-h/2) + S.x10*phi1G - S.x1*phi1G + S.x11*phi1B - S.x2*phi1B;
 x2o= e2o - phi1G*S.x7 - phi1B*S.x8- S.x4*(G2o-(G1o+phi1G))- S.x5*(B2o-(B1o+phi1B)) - S.x6*(H2o-H1o)+ S.x12*phi2G - S.x4*phi2G + S.x13*phi2B- S.x5*phi2B   ;
 x3o= e3o - phi1G*S.x7 - phi1B*S.x8 -S.x7*(G3o-(G1o+phi1G))- S.x8*(B3o-(B1o+phi1B)) - S.x9*(H3o-H1o) +S.x14*phi3G - S.x7*phi3G + S.x15*phi3B -S.x8*phi3B ;
 x4o= e4o - phi2G*G - phi2B*B + H2o  + G2o + phi2G +B2o+phi2B;
 x5o=e5o-phi2G*G-phi2B*B + H2o  + G*(G2o + phi2G) +B*(B2o+phi2B);
x6o=e6o-phi3G*G-phi3B*B+ H3o + G3o + phi3G +B3o+phi3B;
 x7o=e7o-phi3G*G-phi3B*B+ H3o + G*(G3o + phi3G) +B*(B3o+phi3B);
 x8o=e8o-phi3G*G-phi3B*B+ H*H3o + G3o + phi3G +B3o+phi3B;
 x9o=e9o-phi3G*G-phi3B*B+ H*H3o + G*(G3o + phi3G) +B*(B3o+phi3B);





%Market Clearing

%s=1

theta1G=phi1G;
theta1B=phi1B;

%s=2

theta2G=phi2G;
theta2B=phi2B;

%s=3

theta3G=phi3G;
theta3B=phi3B;

%Budget Constraint Pesimist

x1p=  e1p - S.x1*(G1p-g/2) - S.x2*(B1p-b/2) -S.x3*(H1p-h/2) - S.x10*theta1G - S.x11*theta1B ;
x2p= e2p + theta1G*S.x7 +theta1B*S.x8- S.x4*(G2p-(G1p))- S.x5*(B2p-(B1p)) - S.x6*(H2p-H1p)- S.x12*theta2G- S.x13*theta2B   ;
x3p= e3p + theta1G*S.x7 +theta1B*S.x8   - S.x7*(G3p-(G1p))- S.x8*(B3p-(B1p)) - S.x9*(H3p-H1p) -S.x14*theta3G - S.x15*theta3B ;
x4p=  e4p+theta2G*G+theta2B*B + H2p  + G2p  +B2p;
x5p=e5p+theta2G*G+theta2B*B+ H2p  + G*(G2p) +B*(B2p);
x6p=e6p+theta3G*G+theta3B*B+ H3p + G3p + B3p;
x7p=e7p+theta3G*G+theta3B*B+ H3p + G*(G3p) +B*(B3p);
x8p=e8p+theta3G*G+theta3B*B+ H*H3p + G3p  +B3p;
x9p=e9p+theta3G*G+theta3B*B+ H*H3p + G*(G3p) +B*(B3p);


Co.x1o=x1o;
Co.x2o=x2o;
Co.x3o=x3o;
Co.x4o=x4o;
Co.x5o=x5o;
Co.x6o=x6o;
Co.x7o=x7o;
Co.x8o=x8o;
Co.x9o=x9o;

Cp.x1p=x1p;
Cp.x2p=x2p;
Cp.x3p=x3p;
Cp.x4p=x4p;
Cp.x5p=x5p;
Cp.x6p=x6p;
Cp.x7p=x7p;
Cp.x8p=x8p;
Cp.x9p=x9p;


L.phi1G=phi1G;
L.phi2G=phi2G;
L.phi3G=phi3G;
L.phi1B=phi1B;
L.phi2B=phi2B;
L.phi3B=phi3B;

Ao.G1o=0;
Ao.G2o=0;
Ao.G3o=0;
Ao.B1o=0;
Ao.B2o=0;
Ao.B3o=0;
Ao.H1o=h;
Ao.H2o=0;
Ao.H3o=h;


Ap.G1p=0;
Ap.G2p=0;
Ap.G3p=0;
Ap.B1p=0;
Ap.B2p=0;
Ap.B3p=0;
Ap.H1p=0;
Ap.H2p=h;
Ap.H3p=0;


FG=(S.x1-S.x7)/S.x1*100;
FB=(S.x2-S.x8)/S.x2*100;
FH=(S.x3-S.x9)/S.x3*100;
CG=(S.x4-S.x7)/S.x4*100;
CB=(S.x5-S.x8)/S.x5*100;
CH=(S.x6-S.x9)/S.x6*100;

p.p1G=S.x1;
p.p1B=S.x2;
p.p1H=S.x3;
p.p2G=S.x4;
p.p2B=S.x5;
p.p2H=S.x6;
p.p3G=S.x7;
p.p3B=S.x8;
p.p3H=S.x9;





%Checking FOC

%Optimist
%s=1

og1= (1/x1o)*(S.x1) - po*delta*(1/x2o)*(S.x4) - (1-po)*delta*(1/x3o)*(S.x7)
ob1= (1/x1o)*(S.x2) - po*delta*(1/x2o)*(S.x5) - (1-po)*delta*(1/x3o)*(S.x8)
obg1= (1/x1o)*S.x10 - po*delta*(1/x2o)*S.x7 - (1-po)*delta*(1/x3o)*S.x7
obb1= (1/x1o)*S.x11 - po*delta*(1/x2o)*S.x8 - (1-po)*delta*(1/x3o)*S.x8



%s=2


og2= (1/x2o)*(S.x4) - po*delta*(1/x4o)*(1) - (1-po)*delta*(1/x5o)*(G)
ob2= (1/x2o)*(S.x5) - po*delta*(1/x4o)*(1) - (1-po)*delta*(1/x5o)*(B)
oh2= (1/x2o)*(S.x6) - po*delta*(1/x4o) - (1-po)*delta*(1/x5o)
obg2= (1/x2o)*S.x12 - po*delta*(1/x4o)*G - (1-po)*delta*(1/x5o)*G
obb2= (1/x2o)*S.x13 - po*delta*(1/x4o)*B - (1-po)*delta*(1/x5o)*B

%s=3


og3= (1/x3o)*(S.x7) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(G)- po*(1-po)*delta*(1/x8o)*(1)- (1-po)*(1-po)*delta*(1/x9o)*(G)
ob3= (1/x3o)*(S.x8) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(B)- po*(1-po)*delta*(1/x8o)*(1)- (1-po)*(1-po)*delta*(1/x9o)*(B)
obg3= (1/x3o)*S.x14 - po*po*delta*(1/x6o)*(G) - po*(1-po)*delta*(1/x7o)*(G)- po*(1-po)*delta*(1/x8o)*(G)- (1-po)*(1-po)*delta*(1/x9o)*(G)
obb3= (1/x3o)*S.x15- po*po*delta*(1/x6o)*(B) - po*(1-po)*delta*(1/x7o)*(B)- po*(1-po)*delta*(1/x8o)*(B)- (1-po)*(1-po)*delta*(1/x9o)*(B)


%Pesimist
%s=1

pg1= (1/x1p)*(S.x1) - pp*delta*(1/x2p)*(S.x4) - (1-pp)*delta*(1/x3p)*(S.x7)
pb1= (1/x1p)*(S.x2) - pp*delta*(1/x2p)*(S.x5) - (1-pp)*delta*(1/x3p)*(S.x8)
ph1= (1/x1p)*(S.x3) - pp*delta*(1/x2p)*(S.x6) - (1-pp)*delta*(1/x3p)*(S.x9)





%s=2



pg2= (1/x2p)*(S.x4) - pp*delta*(1/x4p)*(1) - (1-pp)*delta*(1/x5p)*(G)
pb2= (1/x2p)*(S.x5) - pp*delta*(1/x4p)*(1) - (1-pp)*delta*(1/x5p)*(B)




%s=3

pg3= (1/x3p)*(S.x7) - pp*pp*delta*(1/x6p)*(1) - pp*(1-pp)*delta*(1/x7p)*(G)- pp*(1-pp)*delta*(1/x8p)*(1)- (1-pp)*(1-pp)*delta*(1/x9p)*(G)
pb3= (1/x3p)*(S.x8) - pp*pp*delta*(1/x6p)*(1) - pp*(1-pp)*delta*(1/x7p)*(B)- pp*(1-pp)*delta*(1/x8p)*(1)- (1-pp)*(1-pp)*delta*(1/x9p)*(B)
ph3= (1/x3p)*(S.x9) - pp*pp*delta*(1/x6p)*(1) - pp*(1-pp)*delta*(1/x7p)*(1)- pp*(1-pp)*delta*(1/x8p)*(H)- (1-pp)*(1-pp)*delta*(1/x9p)*(H)




%ollateral and payoff value 



%s=1
ag1=po*delta*(1/x2o)*(S.x4) + (1-po)*delta*(1/x3o)*(S.x7);
PVG1=ag1/(1/x1o);
r1=(S.x10/S.x7)-1;
f1= (po*delta*(1/x2o) + (1-po)*delta*(1/x3o))/(1/x1o);
w1=(1/(f1*(1+r1)))-1;
CVG1=(1/(1+r1))*(w1/(1+w1))*S.x7;

ab1=po*delta*(1/x2o)*(S.x5) + (1-po)*delta*(1/x3o)*(S.x8);
PVB1=ab1/(1/x1o);
CVB1=(1/(1+r1))*(w1/(1+w1))*S.x8;

%s=2
ag2=po*delta*(1/x4o)*(1) + (1-po)*delta*(1/x5o)*(G);
PVG2=ag2/(1/x2o);
r2= (S.x12/G)-1;
f2=(po*delta*(1/x4o) + (1-po)*delta*(1/x5o))/(1/x2o);
w2=(1/(f2*(1+r2)))-1;
CVG2=(1/(1+r2))*(w2/(1+w2))*G;

ab2=po*delta*(1/x4o)*(1) + (1-po)*delta*(1/x5o)*(B);
PVB2=ab2/(1/x2o);
CVB2=(1/(1+r2))*(w2/(1+w2))*B;


%s=3
ag3=po*po*delta*(1/x6o)*(1) + po*(1-po)*delta*(1/x7o)*(G)+ po*(1-po)*delta*(1/x8o)*(1)+ (1-po)*(1-po)*delta*(1/x9o)*(G);
PVG3=ag3/(1/x3o);
r3=(S.x14/G)-1;
f3=(po*po*delta*(1/x6o) + po*(1-po)*delta*(1/x7o)+ po*(1-po)*delta*(1/x8o)+ (1-po)*(1-po)*delta*(1/x9o))/(1/x3o);
w3=(1/(f3*(1+r3)))-1;
CVG3=(1/(1+r3))*(w3/(1+w3))*G;

ab3=po*po*delta*(1/x6o)*(1) + po*(1-po)*delta*(1/x7o)*(B)+ po*(1-po)*delta*(1/x8o)*(1)+ (1-po)*(1-po)*delta*(1/x9o)*(B);
PVB3=ab3/(1/x3o);
CVB3=(1/(1+r3))*(w3/(1+w3))*B;




m1g= (S.x1-S.x10)/S.x1;
m2g= (S.x4-S.x12)/S.x4;
m3g= (S.x7-S.x14)/S.x7;

1-m1g;
1-m2g;
1-m3g;

m1b= (S.x2-S.x11)/S.x2;
m2b= (S.x5-S.x13)/S.x5;
m3b= (S.x8-S.x15)/S.x8;

1-m1b;
1-m2b;
1-m3b;


p
FG
FB
FH
CG
CB
CH
w1
PVG1
CVG1
PVB1
CVB1
w2
PVG2
CVG2
PVB2
CVB2
w3
PVG3
CVG3
PVB3
CVB3

(PVG2-PVG3)/S.x4*100
(PVG1-PVG3)/S.x1*100
(CVG2-CVG3)/S.x4*100
(CVG1-CVG3)/S.x1*100

(PVB2-PVB3)/S.x5*100
(PVB1-PVB3)/S.x2*100
(CVB2-CVB3)/S.x5*100
(CVB1-CVB3)/S.x2*100

m1g
m2g
m3g
m1b
m2b
m3b
1-m1g
1-m2g
1-m3g
1-m1b
1-m2b
1-m3b

mu2= (po*(1/x2o))/(po*(1/x2o) + (1-po)*(1/x3o));
mu3=((1-po)*(1/x3o))/(po*(1/x2o) + (1-po)*(1/x3o));
mu4= (po*(1/x4o))/(po*(1/x4o) + (1-po)*(1/x5o));
mu5= ((1-po)*(1/x5o))/(po*(1/x4o) + (1-po)*(1/x5o));
mu6= (po*po*(1/x6o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu7= (po*(1-po)*(1/x7o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu8= (po*(1-po)*(1/x8o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));
mu9= ((1-po)*(1-po)*(1/x9o))/ (po*po*(1/x6o)+ po*(1-po)*(1/x7o)+ po*(1-po)*(1/x8o)+ (1-po)*(1-po)*(1/x9o));

mu2
mu3
mu4
mu5
mu6
mu7
mu8
mu9
