clear all
%Simulation 7: Incomplete Markets, Heterogeneous Agents, 3 Assets, Adverse Selection  with Collateral%


%parameters

syms H G B h b1 b2 b3; 
syms e1o e2o e3o e4o  e5o e6o e7o e8o e9o;
syms e1p e2p e3p e4p  e5p e6p e7p e8p e9p;
syms po pp;
syms delta;

syms e1g1 e4g1  e5g1  e6g1 e7g1 e8g1 e9g1 ;
syms e2g2 e3g2 e4g2  e5g2  e6g2 e7g2 e8g2 e9g2 ;
syms e1b1 e4b1  e5b1  e6b1 e7b1 e8b1 e9b1 ;
syms e2b2 e3b2 e4b2  e5b2  e6b2 e7b2 e8b2 e9b2 ;


syms  beta deltac

% variables


syms x1o x2o x3o  x4o x5o x6o x7o  x8o  x9o ;
syms G1o G2o G3o  B1o B2o B3o  H1o H2o H3o ;
syms phi1G   phi2G phi3G  phi1B   phi2B phi3B ;
syms x1p x2p x3p  x4p x5p x6p x7p  x8p  x9p ;
syms G1p G2p G3p  B1p B2p B3p  H1p H2p H3p ;
syms theta1G  theta2G theta3G  theta1B  theta2B theta3B ;
syms x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 x11 x12 x13 x14 x15 x16 x17 x18 ;

syms x1g1 x4g1  x5g1  x6g1 x7g1 x8g1 x9g1 ;
syms x2g2 x3g2 x4g2  x5g2  x6g2 x7g2 x8g2 x9g2 ;
syms x1b1 x4b1  x5b1  x6b1 x7b1 x8b1 x9b1 ;
syms x2b2 x3b2 x4b2  x5b2  x6b2 x7b2 x8b2 x9b2 ;




% values variables




G1o=0;
G2o=0;
G3o=0;
B1o=0;
B2o=0;
B3o=0;

H1o=h;
H2o=0;
H3o=2*h;

G1p=0;
G2p=0;
G3p=0;

B1p=0;
B2p=0;
B3p=0;

H1p=0;
H2p=2*h;
H3p=0;

phi1G=x16;
phi2G=x16+x17;
phi3G=x16+x18;
phi1B=b1;
phi2B=b1+b2;
phi3B=b1+b3;


%equations

%Budget Constraints Optimist

x1o=  e1o - x1*G1o - x2*B1o -x3*(H1o-h/2) + x10*phi1G - x1*phi1G + x11*phi1B - x2*phi1B;
 x2o= e2o - phi1G*x7 - phi1B*x8- x4*(G2o-(G1o+phi1G))- x5*(B2o-(B1o+phi1B)) - x6*(H2o-H1o-h/2)+ x12*phi2G - x4*phi2G + x13*phi2B- x5*phi2B   ;
 x3o= e3o - phi1G*x7 - phi1B*x8 -x7*(G3o-(G1o+phi1G))- x8*(B3o-(B1o+phi1B)) - x9*(H3o-H1o-h/2) +x14*phi3G - x7*phi3G + x15*phi3B -x8*phi3B ;
 x4o= e4o - phi2G*G - phi2B*B + H2o  + G2o + phi2G +B2o+phi2B;
 x5o=e5o-phi2G*G-phi2B*B + H2o  + G*(G2o + phi2G) +B*(B2o+phi2B);
x6o=e6o-phi3G*G-phi3B*B+ H3o + G3o + phi3G +B3o+phi3B;
 x7o=e7o-phi3G*G-phi3B*B+ H3o + G*(G3o + phi3G) +B*(B3o+phi3B);
 x8o=e8o-phi3G*G-phi3B*B+ H*H3o + G3o + phi3G +B3o+phi3B;
 x9o=e9o-phi3G*G-phi3B*B+ H*H3o + G*(G3o + phi3G) +B*(B3o+phi3B);


 % Budget Constraints of G1

x1g1=e1g1+x1*x16;
x4g1=e4g1+1-x16;
x5g1=e5g1+G*(1-x16);
x6g1=e6g1+1-x16;
x7g1=e7g1+  G*(1-x16);
x8g1=e8g1+1-x16;
x9g1=e9g1+  G*(1-x16);

% Budget Constraints of B1

x1b1=e1b1+x2*b1;
x4b1=e4b1+(1-b1);
x5b1=e5b1+B*(1-b1);
x6b1=e6b1+(1-b1);
x7b1=e7b1+B*(1-b1);
x8b1=e8b1+(1-b1);
x9b1=e9b1+B*(1-b1);



%Budget Constraint of G2

x2g2=e2g2+x4*x17;
x3g2=e3g2+x7*x18;
x4g2=e4g2+1-x17;
x5g2=e5g2+G*(1-x17);
x6g2=e6g2+1-x18;
x7g2=e7g2+G*(1-x18);
x8g2=e8g2+1-x18;
x9g2=e9g2+G*(1-x18);

%Budget Constraint of B2

x2b2=e2b2+x5*b2;
x3b2=e3b2+x8*b3;
x4b2=e4b2+(1-b2);
x5b2=e5b2+B*(1-b2);
x6b2=e6b2+(1-b3);
x7b2=e7b2+B*(1-b3);
x8b2=e8b2+(1-b3);
x9b2=e9b2+B*(1-b3);

%Market Clearing

%s=1

theta1G=phi1G;
theta1B=phi1B;

%s=2

theta2G=phi2G;
theta2B=phi2B;

%s=3

theta3G=phi3G;
theta3B=phi3B;

%Budget Constraint Pesimist

x1p=  e1p - x1*G1p - x2*B1p -x3*(H1p-h/2) - x10*theta1G - x11*theta1B ;
x2p= e2p + theta1G*x7 +theta1B*x8- x4*(G2p-(G1p))- x5*(B2p-(B1p)) - x6*(H2p-H1p-h/2)- x12*theta2G- x13*theta2B   ;
x3p= e3p + theta1G*x7 +theta1B*x8   - x7*(G3p-(G1p))- x8*(B3p-(B1p)) - x9*(H3p-H1p-h/2) - x14*theta3G - x15*theta3B ;
x4p=  e4p+theta2G*G+theta2B*B + H2p  + G2p  +B2p;
x5p=e5p+theta2G*G+theta2B*B+ H2p  + G*(G2p) +B*(B2p);
x6p=e6p+theta3G*G+theta3B*B+ H3p + G3p + B3p;
x7p=e7p+theta3G*G+theta3B*B+ H3p + G*(G3p) +B*(B3p);
x8p=e8p+theta3G*G+theta3B*B+ H*H3p + G3p  +B3p;
x9p=e9p+theta3G*G+theta3B*B+ H*H3p + G*(G3p) +B*(B3p);

%FOC

%s=1

f1= (1/x1o)*(x1-x10) - po*delta*(1/x2o)*(x4-x7) - (1-po)*delta*(1/x3o)*(x7-x7);
f2= (1/x1o)*(x2-x11) - po*delta*(1/x2o)*(x5-x8) - (1-po)*delta*(1/x3o)*(x8-x8);
f3= (1/x1o)*(x3) - po*delta*(1/x2o)*(x6) - (1-po)*delta*(1/x3o)*(x9);
f4= (1/x1p)*x10 - pp*delta*(1/x2p)*x7 - (1-pp)*delta*(1/x3p)*x7;
f5= (1/x1p)*x11 - pp*delta*(1/x2p)*x8 - (1-pp)*delta*(1/x3p)*x8;

%s=2

f6= (1/x2o)*(x4-x12) - po*delta*(1/x4o)*(1-G) - (1-po)*delta*(1/x5o)*(G-G);
f7= (1/x2o)*(x5-x13) - po*delta*(1/x4o)*(1-B) - (1-po)*delta*(1/x5o)*(B-B);
f8= (1/x2p)*(x6) - pp*delta*(1/x4p) - (1-pp)*delta*(1/x5p);
f9= (1/x2p)*x12 - pp*delta*(1/x4p)*G - (1-pp)*delta*(1/x5p)*G;
f10= (1/x2p)*x13 - pp*delta*(1/x4p)*B - (1-pp)*delta*(1/x5p)*B;

%s=3

f11= (1/x3o)*(x7-x14) - po*po*delta*(1/x6o)*(1-G) - po*(1-po)*delta*(1/x7o)*(G-G)- po*(1-po)*delta*(1/x8o)*(1-G)- (1-po)*(1-po)*delta*(1/x9o)*(G-G);
f12= (1/x3o)*(x8-x15) - po*po*delta*(1/x6o)*(1-B) - po*(1-po)*delta*(1/x7o)*(B-B)- po*(1-po)*delta*(1/x8o)*(1-B)- (1-po)*(1-po)*delta*(1/x9o)*(B-B);
f13= (1/x3o)*(x9) - po*po*delta*(1/x6o)*(1) - po*(1-po)*delta*(1/x7o)*(1)- po*(1-po)*delta*(1/x8o)*(H)- (1-po)*(1-po)*delta*(1/x9o)*(H);
f14= (1/x3p)*x14 - pp*pp*delta*(1/x6p)*(G) - pp*(1-pp)*delta*(1/x7p)*(G)- pp*(1-pp)*delta*(1/x8p)*(G)- (1-pp)*(1-pp)*delta*(1/x9p)*(G);
f15= (1/x3p)*x15- pp*pp*delta*(1/x6p)*(B) - pp*(1-pp)*delta*(1/x7p)*(B)- pp*(1-pp)*delta*(1/x8p)*(B)- (1-pp)*(1-pp)*delta*(1/x9p)*(B);

%Incentive Compatibility Constraints.


f16=(e1b1+x2*b1 -beta*(e1b1+x2*b1)^2)+po*po*(e4b1+(1-b1)-beta*(e4b1+(1-b1))^2)+(1-po)*po*(e5b1+B*(1-b1)-beta*(e5b1+B*(1-b1))^2)+(1-po)*po*po*(e6b1+(1-b1)-beta*(e6b1+(1-b1))^2)+(1-po)*po*(1-po)*(e7b1+B*(1-b1)-beta*(e7b1+B*(1-b1))^2)+ (1-po)*(1-po)*po*(e8b1+(1-b1)-beta*(e8b1+(1-b1))^2)+(1-po)*(1-po)*(1-po)*(e9b1+B*(1-b1)-beta*(e9b1+B*(1-b1))^2)-(e1b1+x1*x16 - beta*(e1b1+x1*x16)^2)-po*po*(e4b1+1-x16-beta*(e4b1+1-x16)^2)-(1-po)*po*(e5b1+B*(1-x16)-beta*(e5b1+B*(1-x16))^2)-(1-po)*po*po*(e6b1+1-x16-beta*(e6b1+1-x16)^2)-(1-po)*po*(1-po)*(e7b1+B*(1-x16)-beta*(e7b1+B*(1-x16))^2)- (1-po)*(1-po)*po*(e8b1+1-x16-beta*(e8b1+1-x16)^2)-(1-po)*(1-po)*(1-po)*(e9b1+B*(1-x16)-beta*(e9b1+B*(1-x16))^2);
f17=(e2b2+x5*b2 - beta*(e2b2+x5*b2)^2)+po*(e4b2+(1-b2)-beta*(e4b2+(1-b2))^2)+(1-po)*(e5b2+B*(1-b2)-beta*(e5b2+B*(1-b2))^2)-(e2b2+x4*x17 - beta*(e2b2+x4*x17)^2)-po*(e4b2+1-x17-beta*(e4b2+1-x17)^2)-(1-po)*(e5b2+B*(1-x17)-beta*(e5b2+B*(1-x17))^2);
f18=(e3b2+x8*b3 - beta*(e3b2+x8*b3)^2)+ po*po*(e6b2+(1-b3)-beta*(e6b2+(1-b3))^2)+(1-po)*po*(e7b2+B*(1-b3)-beta*(e7b2+B*(1-b3))^2)+(1-po)*po*(e8b2+(1-b3)-beta*(e8b2+(1-b3))^2)+(1-po)*(1-po)*(e9b2+B*(1-b3)-beta*(e9b2+B*(1-b3))^2)-(e3b2+x7*x18 - beta*(e3b2+x7*x18)^2)- po*po*(e6b2+1-x18-beta*(e6b2+1-x18)^2)-(1-po)*po*(e7b2+B*(1-x18)-beta*(e7b2+B*(1-x18))^2)-(1-po)*po*(e8b2+1-x18-beta*(e8b2+1-x18)^2)-(1-po)*(1-po)*(e9b2+B*(1-x18)-beta*(e9b2+B*(1-x18))^2);

